package com.zipcodewilmington;
import java.util.*;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length-1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length-2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for (String s : array) {
            if(s  == value) {
                return true;
            }
        }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        int count = 0;
        String[] finArray = new String[array.length];
        for(int i = array.length-1; i >= 0; i--){
            finArray[count] = array[i];
            count ++ ;
        }
        return finArray;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] newArray = reverse(array);
        for(int i = 0; i < array.length; i++)
            if(newArray[i] == array[i]){
                return true;
            }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        String fullSentence = Arrays.toString(array).toLowerCase();

        for(Character i ='a'; i <='z'; i++){
            if(!fullSentence.contains(String.valueOf(i))){
                return false;
            }
        }
        return true;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int count = 0;
        for(String word : array){
            if(word.equals(value)){
                count ++;
            }
        }

        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] newArr = new String[array.length];
        int count = 0;
        for (int i = 0; i < array.length; i++) {
            if (!array[i].equals(valueToRemove)) {
                newArr[count] = array[i];
                count++;
            }

        }
        return Arrays.copyOf(newArr, count);
    }
        /**
         * @param array array of chars
         * @return array of Strings with consecutive duplicates removes
         */ // TODO
        public static String[] removeConsecutiveDuplicates (String[]array){
            String[] newArr = new String[array.length];
            int count = 0;
            for (int i = 1; i < array.length; i++) {
                String current = array[i-1];
                if (!current.equals(array[i])) {
                    newArr[count] = array[i-1];

                    count++;
                    System.out.println(array[i]);
                }

            }
            newArr[count] = array[array.length-1];
            return Arrays.copyOf(newArr, count +1);
        }

        /**
         * @param array array of chars
         * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
         */ // TODO
        public static String[] packConsecutiveDuplicates (String[]array){
            StringBuilder build = new StringBuilder();

            build.append(array[0]);

            for (int i = 1; i < array.length; i++) {
                if (!array[i].equals(array[i-1])) {
                    build.append(" " + array[i]);
                    System.out.println(build);
                }else{
                    build.append(array[i]);
                    System.out.println(build);
                }

            }
          return build.toString().split(" ");
        }


}
